Index: trunk/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionLedger/FrmConstructionLedgerAuxiliary.cs
===================================================================
--- trunk/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionLedger/FrmConstructionLedgerAuxiliary.cs	(revision 5)
+++ trunk/src/ProcessManagement/ProcessManagement/Forms/DataEntry/ConstructionLedger/FrmConstructionLedgerAuxiliary.cs	(revision 6)
@@ -3783,9 +4579,1276 @@
             finally
             {
                 BudgetDB.close(); BudgetDB = null;
+            }
+        }
+        #endregion
+
+        #region 指導員給与文字列を作成する
+        /// <summary>
+        /// 指導員給与文字列を作成する
+        /// </summary>
+        /// <returns></returns>
+        private string MakeInstructorSalaryString()
+        {
+            IOConstructionBudget BudgetDB = new IOConstructionBudget();
+            try
+            {
+                string sRet = string.Empty;
+
+                // 工事予算書データを読み込む
+                string strSQL = BudgetDB.CreatePrimarykeyString(m_ConstructionCode);
+                ConstructionBudget BudgetRec = new ConstructionBudget();
+                if (!BudgetDB.SelectAction(strSQL, ref BudgetRec)) return sRet;
+
+                // 設定無は空白
+                if (BudgetRec.InstructorCode == 0) return sRet;
+
+                if (BudgetRec.I_SalaryFlg == (int)CommonDefine.SalaryDevision.All)
+                {   // ----- 全日振分
+                    double BetweenTimes = BudgetRec.ConstructionTimes;
+                    // 給与単価
+                    int monthSalary = CommonDefine.InstructorMonthryCost;
+                    sRet = string.Format(CommonDefine.s_SalaryCostMonthlyFormat, BetweenTimes, monthSalary.ToString("#,0"));
+                }
+                else if (BudgetRec.I_SalaryFlg == (int)CommonDefine.SalaryDevision.DaysInput)
+                {   // ----- 日数指定
+                    // 日数取得
+                    int daycount = BudgetRec.SalaryDays;
+                    // 担当給与
+                    int monthSalary = CommonDefine.InstructorMonthryCost;
+                    // 日額給与取得
+                    double daylySalary = monthSalary / CommonDefine.s_WorkingDaysOfMonth;
+                    sRet = string.Format(CommonDefine.s_SalaryCostDaylyFormat, daycount.ToString("0"), daylySalary.ToString("#,0"));
+                }
+
+                return sRet;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return string.Empty;
+            }
+            finally
+            {
+                BudgetDB.close(); BudgetDB = null;
+            }
+        }
+        #endregion
+
+        #region 副担当者／指導員に名前をセットする
+        /// <summary>
+        /// 副担当者／指導員に名前をセットする
+        /// </summary>
+        /// <param name="DetailRec"></param>
+        private void SetFirstStringName(ref ConstructionBudgetDetail DetailRec)
+        {
+            IOMPersonInCharge PersonDB = new IOMPersonInCharge();
+            try
+            {
+                // 設定無は処理しない
+                if (DetailRec.CompanyCode == 0) return;
+                // 名前があれば処理しない
+                if (DetailRec.FirstString.IndexOf("【") > -1) return;
+
+                // 担当者マスタ取得
+                string strSQL = PersonDB.CreatePrimarykeyString(DetailRec.CompanyCode);
+                PersonInChargeMaster PersonRec = new PersonInChargeMaster();
+                if (!PersonDB.SelectAction(strSQL, ref PersonRec)) return;
+
+                DetailRec.FirstString = string.Format("{0}【{1}氏】", DetailRec.FirstString, PersonRec.SealPrintName);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
                 PersonDB.close(); PersonDB = null;
             }
         }
         #endregion
+
+        #region 副担当者／指導員変更
+        /// <summary>
+        /// 副担当者/指導員変更
+        /// </summary>
+        private void ChangeAssistantOrInstractor(int SelectFlg)
+        {
+            FrmSelectPerson frm = new FrmSelectPerson();
+            IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
+            try
+            {
+                // 選択区分セット
+                frm.SelectFlg = SelectFlg;
+                switch (SelectFlg)
+                {
+                    case (int)CommonDefine.PersonSelectFlg.Assistant:
+                        frm.Person = m_ConstructionBaseInfo.ConstrSubPersonCode;
+                        break;
+                    case (int)CommonDefine.PersonSelectFlg.Instructor:
+                        frm.Person = m_ConstructionBaseInfo.ConstructionInstructor;
+                        break;
+                }
+                // 担当者選択画面表示
+                frm.ShowDialog();
+                if (frm.EndButton == DialogResult.Cancel) return;
+                // 設定値取得
+                int DepartmentCode = frm.Departmanet;
+                int PersonCode = frm.Person;
+                int SalaryFlg = frm.SalaryFlg;
+                int SalaryDays = frm.SalaryDays;
+
+                // 行作成
+                CreateAssistantOrInstractor(SelectFlg, PersonCode, SalaryFlg, SalaryDays);
+
+                //int UpdateField = 0;
+                bool updateflg = false;
+                switch (SelectFlg)
+                {
+                    case (int)CommonDefine.PersonSelectFlg.Assistant:
+                        // 副担当者コードが同じ場合は処理しない
+                        if (PersonCode == m_ConstructionBaseInfo.ConstrSubPersonCode) break;
+
+                        updateflg = true;
+                        // 工事情報の副担当者を更新する
+                        //UpdateField = (int)IOConstructionBaseInfo.ConstructionBaseInfoColumn.CONSTRSUBPERSONCODE;
+
+                        // 内部の工事情報を変更する
+                        m_ConstructionBaseInfo.ConstrSubPersonCode = PersonCode;
+                        break;
+                    case (int)CommonDefine.PersonSelectFlg.Instructor:
+                        // 指導員コードが同じ場合は処理しない
+                        if (PersonCode == m_ConstructionBaseInfo.ConstructionInstructor) break;
+
+                        updateflg = true;
+                        // 工事情報の副担当者を更新する
+                        //UpdateField = (int)IOConstructionBaseInfo.ConstructionBaseInfoColumn.CONSTRUCTIONINSTRUCTOR;
+
+                        // 内部の工事情報を変更する
+                        m_ConstructionBaseInfo.ConstructionInstructor = PersonCode;
+                        break;
+                }
+                if (updateflg)
+                {
+                    // 工事基本情報更新
+                    //BaseDB.UpdateFeild(m_ConstructionCode, UpdateField, PersonCode);
+                    // ヘッダー表示
+                    if (!DispHeader()) return;
+                }
+                m_bChengeAns = true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+                BaseDB.close(); BaseDB = null;
+            }
+        }
+        #endregion
+
+        #region 副担当者／指導員の行を作成／更新する
+        /// <summary>
+        /// 副担当者／指導員の行を作成／更新する
+        /// </summary>
+        /// <param name="SelectFlg"></param>
+        /// <param name="PersonCode"></param>
+        /// <param name="SalaryFlg"></param>
+        /// <param name="SalaryDays"></param>
+        private void CreateAssistantOrInstractor(int SelectFlg, int PersonCode, int SalaryFlg, int SalaryDays)
+        {
+            try
+            {
+                // 検索開始位置とグループ番号をセット
+                int LinePoint = 0;
+                int GroupCount = 0;
+                switch (SelectFlg)
+                {
+                    case (int)CommonDefine.PersonSelectFlg.Assistant:
+                        GroupCount = (int)GroupName_ConstructionLedger.Assistant;
+                        break;
+                    case (int)CommonDefine.PersonSelectFlg.Instructor:
+                        GroupCount = (int)GroupName_ConstructionLedger.Instructor;
+                        break;
+                }
+                // グリッドから対象行を探す
+                LinePoint = SearchOrCreateChangeRow(GroupCount, PersonCode);
+
+                // 行データセット
+                SetRowOnChangeData(GroupCount, LinePoint, SalaryFlg, SalaryDays, PersonCode);
+
+                // 行数の再構成を行う
+                SetCostsRowCount();
+
+                // 請求金額計算
+                CalculateBillingAmount();
+
+                // 純利益計算
+                CalculateNetIncome();
+
+                // 合計計算
+                CreateAllTotal(false);
+
+                /// 現在利益計算
+                CalculateCurrentProfit();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region グリッドからグループカウントとコードより対象行を探し、無い場合は行を作る
+        /// <summary>
+        /// グリッドからグループカウントとコードより対象行を探、無い場合は行を作る
+        /// </summary>
+        /// <param name="GroupCount"></param>
+        /// <param name="SaerchCode"></param>
+        /// <param name="LineCount"></param>
+        /// <returns></returns>
+        private int SearchOrCreateChangeRow(int GroupCount, int SaerchCode)
+        {
+            try
+            {
+                // 検索開始位置とグループ番号をセット
+                int StartPoint = 0;
+                int SearchGroup = GroupCount;
+                switch (GroupCount)
+                {
+                    case (int)GroupName_ConstructionLedger.Assistant:
+                        StartPoint = (int)CostsRowLine.AssistantRowLine;
+                        break;
+                    case (int)GroupName_ConstructionLedger.Instructor:
+                        StartPoint = (int)CostsRowLine.InstructorRowLine;
+                        break;
+                }
+                // グリッドから対象行を探す
+                DataGridView dgv = dgvAllDisplay;
+                bool RowExist = false;
+                int LineCount = 0;
+                // 行が無い場合があるので最大2回戻る（すぐ前があればその次にする）
+                for (int ix = StartPoint; ix > (StartPoint - 2); ix--)
+                {
+                    // 検索グループを取得する
+                    SearchGroup = GroupCount - (StartPoint - ix);
+
+                    // カウントより行を取得する
+                    int SearchLine = 0;
+                    SearchLine = m_CostsRowCount[ix];
+                    // 行が無い場合は前に戻る
+                    if (SearchLine == 0) continue;
+                    
+                    for (int i = SearchLine; i < dgv.RowCount; i++)
+                    {
+                        // グループが違えばループを抜ける
+                        int RowGroupNo = CommonMotions.cnvInt(dgv.Rows[i].Cells[(int)GridColumn.GroupCount].Value);
+                        if (RowGroupNo != SearchGroup)
+                        {
+                            LineCount = i;
+                            break;
+                        }
+                        // 担当者コードが0か同じ場合は行が存在する
+                        int RowCompanyCode = CommonMotions.cnvInt(dgv.Rows[i].Cells[(int)GridColumn.CompanyCode].Value);
+                        if ((RowGroupNo == GroupCount) && (RowCompanyCode == 0 || RowCompanyCode == SaerchCode))
+                        {
+                            LineCount = i;
+                            RowExist = true;
+                            break;
+                        }
+                    }
+                    if (LineCount != 0) break;
+                }
+
+                // 行が無い場合は作成する
+                if (!RowExist)
+                {
+                    DataGridViewAction.CreateNewLine(dgv, ref LineCount);
+                    if (m_CostsRowCount[StartPoint] == 0) m_CostsRowCount[StartPoint] = LineCount;
+                }
+                return LineCount;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return 0;
+            }
+        }
+        #endregion
+
+        #region 変更データのセット
+        /// <summary>
+        /// 変更データのセット
+        /// </summary>
+        /// <param name="GroupCount"></param>
+        /// <param name="InsertCnt"></param>
+        /// <param name="SalaryFlg"></param>
+        /// <param name="SalaryDays"></param>
+        /// <param name="CodeType"></param>
+        /// <param name="PersonCode"></param>
+        private void SetRowOnChangeData(int GroupCount, int InsertCnt, int SalaryFlg, int SalaryDays, int PersonCode)
+        {
+            IOMPersonInCharge PersonDB = new IOMPersonInCharge();
+            try
+            {
+                // 担当者マスタ取得
+                string strSQL = PersonDB.CreatePrimarykeyString(PersonCode);
+                PersonInChargeMaster PersonRec = new PersonInChargeMaster();
+                PersonDB.SelectAction(strSQL, ref PersonRec);
+
+                int CodeType = (int)CommonDefine.SearchLogDataType.Person;
+                double BetweenTimes = CommonMotions.cnvDouble(m_DspLabelCtrl[(int)DspLblCtrlName.BetweenTimes].Text);   // 工期取得
+                double CostsValue = 0;
+                string FirstString = string.Empty;
+                string SecondString = string.Empty;
+                // 項目文字列
+                FirstString = s_GroupTitle[GroupCount];
+                
+                // 金額文字列
+                switch (SalaryFlg)
+                {
+                    case (int)CommonDefine.SalaryDevision.All:       // 全日
+                        // 給与計算
+                        CostsValue = CommonDefine.AssistantMonthryCost * BetweenTimes;
+                        SecondString = string.Format(CommonDefine.s_SalaryCostMonthlyFormat, BetweenTimes, CommonDefine.AssistantMonthryCost.ToString("#,0"));
+                        FirstString = string.Format("{0}【{1}氏】", s_GroupTitle[GroupCount], PersonRec.SealPrintName);
+
+                        break;
+                    case (int)CommonDefine.SalaryDevision.Noting:    // 振分無
+                        CodeType = 0;
+                        PersonCode = 0;
+                        SecondString = string.Empty;
+                        break;
+                    case (int)CommonDefine.SalaryDevision.DaysInput: // 日数入力
+                        // 日額給与取得
+                        double daylySalary = CommonDefine.AssistantMonthryCost / CommonDefine.s_WorkingDaysOfMonth;
+                        CostsValue = daylySalary * SalaryDays;
+                        SecondString = string.Format(CommonDefine.s_SalaryCostDaylyFormat, SalaryDays.ToString("0"), daylySalary.ToString("#,0"));
+                        FirstString = string.Format("{0}【{1}氏】", s_GroupTitle[GroupCount], PersonRec.SealPrintName);
+                        break;
+                }
+                DataGridView dgv = dgvAllDisplay;
+                // 設定データセット
+                DataGridViewRow SetData = dgv.Rows[InsertCnt];
+                SetData.Cells[(int)GridColumn.GroupCount].Value = GroupCount;
+
+                SetData.Cells[(int)GridColumn.ItemName].Value = FirstString;
+                SetData.Cells[(int)GridColumn.TextName].Value = SecondString;
+                SetData.Cells[(int)GridColumn.CompanyType].Value = CodeType;
+                SetData.Cells[(int)GridColumn.CompanyCode].Value = PersonCode;
+                SetData.Cells[(int)GridColumn.ExecPrice].Value = CostsValue.ToString("#,0");
+                SetData.Cells[(int)GridColumn.Percent].Value = CalculattionPercent(CostsValue).ToString("0.00");
+
+                SetData.Cells[(int)GridColumn.IndependentFlg].Value = "1";
+                SetData.Cells[(int)GridColumn.FluctuationFlg].Value = "0";
+
+                // フラグセット
+                SetData.Cells[(int)GridColumn.TitleFlg].Value = "0";
+                SetData.Cells[(int)GridColumn.TotalFlg].Value = "0";
+                SetData.Cells[(int)GridColumn.BlankFlg].Value = "0";
+
+                // フィールドロック制御
+                SetData.Cells[(int)GridColumn.ItemName].ReadOnly = false;
+                SetData.Cells[(int)GridColumn.TextName].ReadOnly = false;
+                SetData.Cells[(int)GridColumn.CompanyName].ReadOnly = false;
+                SetData.Cells[(int)GridColumn.ExecPrice].ReadOnly = false;
+
+                // ----- 行番号を振りなおす
+                // タイトル行を探す
+                int TitleRow = -1;
+                for (int i = InsertCnt; i > 0; i--)
+                {
+                    if (CommonMotions.cnvInt(dgv.Rows[i].Cells[(int)GridColumn.TitleFlg].Value) != 0)
+                    {
+                        TitleRow = i;
+                        break;
+                    }
+                }
+                if (TitleRow < 0) return;
+                int DispNo = CommonMotions.cnvInt(dgv.Rows[TitleRow].Cells[(int)GridColumn.No].Value);
+
+                int no = 1;
+                for (int i = (TitleRow + 1); i < dgv.RowCount; i++)
+                {
+                    if (CommonMotions.cnvInt(dgv.Rows[i].Cells[(int)GridColumn.GroupCount].Value) == 0) break;
+                    dgv.Rows[i].Cells[(int)GridColumn.No].Value = string.Format("{0}-{1}", DispNo, no++);
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                PersonDB.close(); PersonDB = null;
+            }
+        }
+        #endregion
+
+        #region 受注金額変更ウィンドウ表示
+        /// <summary>
+        /// 受注金額変更ウィンドウ表示
+        /// </summary>
+        private void OpenOrderPriceChangeWindow()
+        {
+            FrmValueOfOrderDiag frm = new FrmValueOfOrderDiag();
+            try
+            {
+                // パラメタ設定
+                frm.ConstructionCode = m_ConstructionCode;
+                frm.EditFalg = CheckLeaderOrUser();
+                frm.ShowDialog();
+                if (frm.EndButton != DialogResult.OK) return;
+
+                // 受注金額変更
+                int OrderPrice = frm.OrdersDecisionPrice;
+
+                m_DspLabelCtrl[(int)DspLblCtrlName.OrdersPrice].Text = @"\" + OrderPrice.ToString("#,0");
+
+                // グリッド再計算
+                foreach (DataGridViewRow CurRow in dgvAllDisplay.Rows)
+                {
+                    // 経費は別処理
+                    if (CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.GroupCount].Value) == (int)GroupName_ConstructionLedger.Expenses)
+                    {
+                        ReCalculateExpensess(CurRow);
+                        continue;
+                    }
+                    // 行の再計算
+                    RowReCalculate(CurRow, CurRow.Index, (int)GridColumn.ExecPrice);
+                }
+                m_bChengeAns = true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                frm.Dispose(); frm = null;
+            }
+        }
+        #endregion
+
+        #region グリッド行の再計算
+        /// <summary>
+        /// グリッド行の再計算
+        /// </summary>
+        /// <param name="CurRow"></param>
+        /// <param name="RowIndex"></param>
+        /// <param name="ColumnIndex"></param>
+        private void RowReCalculate(DataGridViewRow CurRow, int RowIndex, int ColumnIndex)
+        {
+            try
+            {
+                DataGridView dgv = dgvAllDisplay;
+                
+                // 明細以外は処理しない
+                if (CommonMotions.chkObjectIsNull(CurRow.Cells[(int)GridColumn.TotalFlg].Value)) return;
+                if (CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.TotalFlg].Value) != 0) return;
+
+                if (CommonMotions.chkObjectIsNull(CurRow.Cells[(int)GridColumn.TitleFlg].Value)) return;
+                if (CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.TitleFlg].Value) != 0) return;
+
+                if (CommonMotions.chkObjectIsNull(CurRow.Cells[(int)GridColumn.BlankFlg].Value)) return;
+                if (CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.BlankFlg].Value) != 0) return;
+
+                // 空白行は処理しない
+                if (BlankLine(RowIndex)) return;
+
+                // グループ番号取得
+                int GroupNo = CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.GroupCount].Value);
+
+                // 入力値編集
+                switch (ColumnIndex)
+                {
+                    case (int)GridColumn.EstimatePrice:
+                        // 予定金額
+                        CurRow.Cells[ColumnIndex].Value = CommonMotions.cnvInt(CurRow.Cells[ColumnIndex].Value).ToString("#,#");
+                        break;
+                    case (int)GridColumn.ExecPrice:
+                        // 実行金額
+                        int execprice = CommonMotions.cnvInt(CurRow.Cells[ColumnIndex].Value);
+                        CurRow.Cells[ColumnIndex].Value = execprice.ToString("#,#");
+
+                        if (GroupNo != (int)GroupName_ConstructionLedger.BillingAmount && GroupNo != (int)GroupName_ConstructionLedger.CurrentProfit)
+                        {
+                            // 比率計算
+                            CurRow.Cells[(int)GridColumn.Percent].Value = CalculattionPercent(execprice).ToString("0.00");
+                        }
+                        break;
+                    default:
+                        // その他
+                        if (ColumnIndex >= (int)GridColumn.payment)
+                        {
+                            CurRow.Cells[ColumnIndex].Value = CommonMotions.cnvInt(CurRow.Cells[ColumnIndex].Value).ToString("#,#");
+                        }
+                        break;
+                }
+
+                // 従属項目がある独立項目であれば自行の合計を表示しない
+                bool bDspTotalFlg = true;
+                int nextRowCnt = CurRow.Index + 1;
+                if (nextRowCnt < dgv.RowCount)
+                {
+                    // 自行は独立項目
+                    if (CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.IndependentFlg].Value) == 1)
+                    {
+                        // 次行は従属項目
+                        if (CommonMotions.cnvInt(dgv.Rows[nextRowCnt].Cells[(int)GridColumn.ChildFlg].Value) == 1)
+                            bDspTotalFlg = false;
+                    }
+                }
+
+                // 支払い合計計算
+                int TotalCols = dgv.ColumnCount + (int)ColPayTotal.Totals;
+                int RowTotal = 0;
+                if (bDspTotalFlg)
+                {
+                    // 支払金額の合計
+                    RowTotal = 0;
+                    for (int i = (int)GridColumn.payment; i < TotalCols; i++)
+                    {
+                        RowTotal += CommonMotions.cnvInt(CurRow.Cells[i].Value);
+                    }
+                }
+                else
+                {   // 表示しないときは支払合計を0にする
+                    RowTotal = 0;
+                }
+
+                // グループによって支払計算の表示等を変更する
+                int ResultCols = dgv.ColumnCount + (int)ColPayTotal.Results;
+                switch (GroupNo)
+                {
+                    case (int)GroupName_ConstructionLedger.NetIncome:
+                        // 純利益は支払金額等を計算しない
+                    case (int)GroupName_ConstructionLedger.BillingAmount:
+                        // 請求金額は支払金額等を計算しない
+                        break;
+                    case (int)GroupName_ConstructionLedger.Expenses:
+                        // 経費は支払総額が全て
+                        CurRow.Cells[TotalCols].Value = RowTotal.ToString("#,0");
+                        CurRow.Cells[ResultCols].Value = "0";
+
+                        // 支払可能額・支払超過の編集
+                        SetOverPayment(CurRow.Index);
+                        break;
+                    default:
+
+                        // 実績表示
+                        int ExecPrice = CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.ExecPrice].Value);
+                        int ResultValue = (ExecPrice - RowTotal);
+                        CurRow.Cells[TotalCols].Value = RowTotal.ToString("#,0");
+                        CurRow.Cells[ResultCols].Value = ResultValue.ToString("#,0");
+
+                        // 支払可能額・支払超過の編集
+                        SetOverPayment(CurRow.Index);
+                        break;
+                }
+                // 請求金額計算
+                CalculateBillingAmount();
+
+                // 純利益計算
+                CalculateNetIncome();
+
+                // 合計計算
+                CreateAllTotal(false);
+
+                /// 現在利益計算
+                CalculateCurrentProfit();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 経費再計算処理
+        /// <summary>
+        /// 経費再計算処理
+        /// </summary>
+        /// <param name="CurRow"></param>
+        private void ReCalculateExpensess(DataGridViewRow CurRow)
+        {
+            try
+            {
+                // 受注金額取得
+                int OrdersPrice = CommonMotions.cnvInt(m_DspLabelCtrl[(int)DspLblCtrlName.OrdersPrice].Text);
+                // 経費率取得
+                double percent = CommonMotions.cnvDouble(CurRow.Cells[(int)GridColumn.Percent].Value);
+
+                // 経費金額計算
+                CurRow.Cells[(int)GridColumn.ExecPrice].Value = ((int)(OrdersPrice * (percent / 100.0))).ToString("#,#");
+                CurRow.Cells[(int)GridColumn.payment].Value = ((int)(OrdersPrice * (percent / 100.0))).ToString("#,#");
+
+                DataGridView dgv = dgvAllDisplay;
+                // 合計欄位置取得
+                int TotalPoint = dgv.ColumnCount + (int)ColPayTotal.Totals;
+                CurRow.Cells[TotalPoint].Value = ((int)(OrdersPrice * (percent / 100.0))).ToString("#,#");
+                // 実績欄位置取得
+                int ResultPoint = dgv.ColumnCount + (int)ColPayTotal.Results;
+                CurRow.Cells[ResultPoint].Value = "0";
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 増減工事データの存在確認
+        /// <summary>
+        /// 増減工事データの存在確認
+        /// </summary>
+        /// <returns></returns>
+        private bool ExistFluctuationData()
+        {
+            IOConstructionLink LinkDB = new IOConstructionLink();
+            try
+            {
+                string strSQL = "SELECT COUNT(*) FROM CONSTRUCTIONBASEINFO";
+                strSQL += " WHERE CONSTRUCTIONCODE";
+                strSQL += " IN (SELECT A.FLUCTUATIONCODE";
+                strSQL += " FROM CONSTRUCTIONLINK A, PROCESSAPPROVAL B";
+                strSQL += string.Format(" WHERE A.CONSTRUCTIONCODE = {0}", m_ConstructionCode);
+                strSQL += " AND A.CONSTRUCTIONCODE = B.CONSTRUCTIONCODE";
+                strSQL += string.Format(" AND B.APPROVALCODE = {0})", (int)ClsExcute.ApprovalListNo.ConstructionBudgetApproval);
+                strSQL += string.Format(" AND CONSTRUCTIONSTATUSFLG != {0}", CommonDefine.ProjectsStatus.First(x => x.Value.Equals("非 受 注")).Key);
+
+                ArrayList arList = new ArrayList();
+                if (!LinkDB.ExecuteReader(strSQL, ref arList)) return false;
+
+                object[] wrkobj = (object[])arList[0];
+                // 増減工事データが存在しない場合は無
+                if (CommonMotions.cnvInt(wrkobj[0]) == 0) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                LinkDB.close(); LinkDB = null;
+            }
+        }
+        #endregion
+
+        #region 増減データを台帳データへ追加する
+        /// <summary>
+        /// 増減データを台帳データへ追加する
+        /// </summary>
+        /// <returns></returns>
+        private bool AdditionLedgerData()
+        {
+            try
+            {
+                // 受注金額を変更する
+                if (!SetAddData_OrderPrice()) return false;
+
+                // 経費を再計算
+                if (!SetAddData_Expeness()) return false;
+
+                // 工事予算書より施工費を取り込む
+                if (!SetAddData_Construction()) return false;
+
+                // 工事予算書より購入品ブロックを取り込む
+                if (!SetAddData_OtherExpeness()) return false;
+
+                // 工事予算書より人件費ブロックを取り込む
+                if (!SetAddData_WorkingValue()) return false;
+
+                // 純利益行計算
+                CalculateNetIncome();
+
+                // 合計金額
+                CreateAllTotal(false);
+
+                // 請求金額計算
+                CalculateBillingAmount();
+
+                // 現在利益作成
+                CalculateCurrentProfit();
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region データ追加：受注金額の変更
+        /// <summary>
+        /// データ追加：受注金額の変更
+        /// </summary>
+        private bool SetAddData_OrderPrice()
+        {
+            IOConstructionBaseInfo BaseDB = new IOConstructionBaseInfo();
+            try
+            {
+                // 受注金額取得
+                int OrdersPrice = CommonMotions.cnvInt(m_DspLabelCtrl[(int)DspLblCtrlName.OrdersPrice].Text);
+
+                string strSQL = BaseDB.CreatePrimarykeyString(m_AddingConstrCode);
+                ConstructionBaseInfo BaseRec = new ConstructionBaseInfo();
+                if(!BaseDB.SelectAction(strSQL, ref BaseRec)) return false;
+
+                OrdersPrice += (int)BaseRec.OrdersDecisionPrice;
+
+                // 受注金額
+                m_DspLabelCtrl[(int)DspLblCtrlName.OrdersPrice].Text = @"\" + OrdersPrice.ToString("#,0");
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                BaseDB.close(); BaseDB = null;
+            }
+        }
+        #endregion
+
+        #region データ追加：経費再計算
+        /// <summary>
+        /// データ追加：経費再計算
+        /// </summary>
+        private bool SetAddData_Expeness()
+        {
+            try
+            {
+                DataGridView dgv = dgvAllDisplay;
+
+                int GroupNo = (int)GroupName_ConstructionLedger.Expenses;
+                // 受注金額取得
+                double OrdersPrice = CommonMotions.cnvInt(m_DspLabelCtrl[(int)DspLblCtrlName.OrdersPrice].Text);
+
+                // 行位置取得
+                int StartLine = m_CostsRowCount[(int)CostsRowLine.ExpensesRowLine];
+
+                // ----- 経費支払月の計算
+                // 現在年月日取得
+                string NowMonth = string.Format("{0}/{1}/1", DateTime.Now.Year, DateTime.Now.Month);
+                // 工事開始年月取得
+                string StartHeder = CommonMotions.cnvString(dgv.Columns[(int)GridColumn.payment].HeaderCell.Value).Replace("年", "/").Replace("月", "/") + "1";
+
+                // 経過月数計算
+                DateTime StDate = CommonMotions.cnvDate(StartHeder);
+                DateTime EdDate = CommonMotions.cnvDate(NowMonth);
+                int Betwen = (int)GridColumn.payment + MonthDiff(StDate, EdDate);
+
+                for (int i = StartLine; i < dgv.RowCount; i++)
+                {
+                    DataGridViewRow GridRow = dgv.Rows[i];
+
+                    // 経費グループ以外は処理しない
+                    if (CommonMotions.cnvInt(GridRow.Cells[(int)GridColumn.GroupCount].Value) != GroupNo) break;
+
+                    // 経費取得
+                    double dExpenses = CommonMotions.cnvDouble(GridRow.Cells[(int)GridColumn.Percent].Value);
+
+                    // 現在値取得
+                    double NowValue = CommonMotions.cnvInt(GridRow.Cells[(int)GridColumn.ExecPrice].Value);
+                    // 金額計算
+                    double CalcValue = OrdersPrice * (dExpenses / 100.0);
+
+                    // データセット 元の金額は変更しない
+                    //GridRow.Cells[(int)DispGridColumn.ExecPrice].Value = ((int)CalcValue).ToString("#,#");
+
+                    // 支払金額セット
+                    if (Betwen == (int)GridColumn.payment)
+                    {   // 工期が１カ月しかない場合
+                        GridRow.Cells[Betwen].Value = ((int)CalcValue).ToString("#,#");
+                    }
+                    else
+                    {   // 工期が数カ月ある場合
+                        GridRow.Cells[Betwen].Value = ((int)(CalcValue - NowValue)).ToString("#,#");
+                    }
+
+                    // 合計欄位置取得
+                    int TotalPoint = dgv.ColumnCount + (int)ColPayTotal.Totals;
+                    GridRow.Cells[TotalPoint].Value = ((int)CalcValue).ToString("#,#");
+                }
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 2つの日付の月差を求める
+        /// <summary>
+        /// 2つの日付の月差を求める
+        /// </summary>
+        /// <param name="dTime1"></param>
+        /// <param name="dTime2"></param>
+        /// <returns></returns>
+        private int MonthDiff(DateTime dTime1, DateTime dTime2)
+        {
+            int iRet = 0;
+            DateTime dtFrom = DateTime.MinValue;
+            DateTime dtTo = DateTime.MaxValue;
+
+            if (dTime1 < dTime2)
+            {
+                dtFrom = dTime1;
+                dtTo = dTime2;
+            }
+            else
+            {
+                dtFrom = dTime2;
+                dtTo = dTime1;
+            }
+
+            // 月差計算（年差考慮(差分1年 → 12(ヶ月)加算)）
+            iRet = (dtTo.Month + (dtTo.Year - dtFrom.Year) * 12) - dtFrom.Month;
+
+            return iRet;
+        }
+        #endregion
+
+        #region データ追加：施工費追加
+        /// <summary>
+        /// データ追加：施工費追加
+        /// </summary>
+        /// <returns></returns>
+        private bool SetAddData_Construction()
+        {
+            IOConstructionBudgetDetail DetailDB = new IOConstructionBudgetDetail();
+            try
+            {
+                // 工事予算書明細データを読み込む
+                string strSQL = DetailDB.CreatePrimarykeyString(m_AddingConstrCode);
+                strSQL += string.Format(" AND (GROUPCOUNT = {0}", (int)GroupName_ConstructionBudget.CommonTempCosts);       // 共通仮設
+                strSQL += string.Format(" OR GROUPCOUNT = {0}", (int)GroupName_ConstructionBudget.OutSourceCosts);          // 外注費
+                strSQL += string.Format(" OR GROUPCOUNT = {0})", (int)GroupName_ConstructionBudget.MyConstruction);         // 自社施工
+                strSQL += " ORDER BY GroupCount ASC, LineCount ASC";
+                List<ConstructionBudgetDetail> DetailList = new List<ConstructionBudgetDetail>();
+                if (!DetailDB.SelectAction(strSQL, ref DetailList)) return false;
+                if (DetailList.Count == 0) return false;
+
+                DataGridView dgv = dgvAllDisplay;
+                int GroupNo = (int)GroupName_ConstructionLedger.ConstructionCosts;
+                int icnt = 0;
+
+                // 行位置取得
+                int StartLine = m_CostsRowCount[(int)CostsRowLine.ConstructionCostLine];
+
+                // データ挿入位置検索
+                int TargetLine = -1;
+                for (int i = StartLine; i < dgv.RowCount; i++)
+                {
+                    DataGridViewRow GridRow = dgv.Rows[i];
+                    if (CommonMotions.cnvInt(GridRow.Cells[(int)GridColumn.GroupCount].Value) != GroupNo) break;
+
+                    // 金額が変わった可能性があるので比率計算
+                    double execprice = CommonMotions.cnvDouble(GridRow.Cells[(int)GridColumn.ExecPrice].Value);
+                    GridRow.Cells[(int)GridColumn.Percent].Value = CalculattionPercent(execprice).ToString("0.00");
+                    
+                    // 同じ場合は行数を退避
+                    TargetLine = i;
+                }
+
+                // データ号現番号取得
+                int FluctuationNo = m_AddingConstrCode % 100;
+                // 次の行から追加
+                TargetLine++;
+                // データ追加
+                foreach (ConstructionBudgetDetail DetailRec in DetailList)
+                {
+                    // 行追加
+                    DataGridViewAction.CreateNewLine(dgv, ref TargetLine);
+
+                    DataGridViewRow GridRow = dgv.Rows[TargetLine];
+
+                    // データセット
+                    GridRow.Cells[(int)GridColumn.No].Value = string.Format("{0}-{1}", GroupNo, ++icnt);
+                    GridRow.Cells[(int)GridColumn.FixFlg].Value = "*";
+                    GridRow.Cells[(int)GridColumn.GroupCount].Value = GroupNo;
+                    GridRow.Cells[(int)GridColumn.ItemName].Value = DetailRec.FirstString;
+                    GridRow.Cells[(int)GridColumn.TextName].Value = DetailRec.SecondString;
+                    GridRow.Cells[(int)GridColumn.CompanyCode].Value = DetailRec.CompanyType;
+                    GridRow.Cells[(int)GridColumn.CompanyCode].Value = DetailRec.CompanyCode;
+                    GridRow.Cells[(int)GridColumn.CompanyName].Value = DetailRec.CompanyName;
+                    GridRow.Cells[(int)GridColumn.EstimatePrice].Value = DetailRec.EstimatePrice.ToString("#,0");
+                    GridRow.Cells[(int)GridColumn.ExecPrice].Value = DetailRec.ExecutionAmount.ToString("#,0");
+                    GridRow.Cells[(int)GridColumn.Percent].Value = CalculattionPercent(DetailRec.ExecutionAmount).ToString("0.00");
+                    GridRow.Cells[(int)GridColumn.IndependentFlg].Value = "1";
+                    GridRow.Cells[(int)GridColumn.FluctuationFlg].Value = FluctuationNo;
+
+                    // 合計欄位置取得
+                    int TotalPoint = dgv.ColumnCount + (int)ColPayTotal.Totals;
+                    GridRow.Cells[TotalPoint].Value = "0";
+                    // 実績欄位置取得
+                    int ResultPoint = dgv.ColumnCount + (int)ColPayTotal.Results;
+                    GridRow.Cells[ResultPoint].Value = DetailRec.ExecutionAmount.ToString("#,0");
+
+                    GridRow.Cells[(int)GridColumn.TitleFlg].Value = "0";
+                    GridRow.Cells[(int)GridColumn.TotalFlg].Value = "0";
+                    GridRow.Cells[(int)GridColumn.BlankFlg].Value = "0";
+
+                    TargetLine++;
+                }
+
+                // 行のエリアを更新する
+                SetCostsRowCount();
+                
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                DetailDB.close(); DetailDB = null;
+            }
+        }
+        #endregion
+
+        #region データ追加：購入品ブロック追加
+        /// <summary>
+        /// データ追加：購入品ブロック追加
+        /// </summary>
+        /// <returns></returns>
+        private bool SetAddData_OtherExpeness()
+        {
+            try
+            {
+                // 交通費表示
+                if (!SetAddData_ConstructionBudget((int)GroupName_ConstructionBudget.TransportationCosts)) return false;
+                // 購入品
+                if (!SetAddData_PurchaseCosts()) return false;
+                // 車両リース代
+                if (!SetAddData_ConstructionBudget( (int)GroupName_ConstructionBudget.VehicleLeaseFee)) return false;
+                // 駐車場・資材置き場
+                if (!SetAddData_ConstructionBudget((int)GroupName_ConstructionBudget.ParkingCosts)) return false;
+                // 宿泊費
+                if (!SetAddData_ConstructionBudget((int)GroupName_ConstructionBudget.RoomChargeCosts)) return false;
+                // 処分費等
+                if (!SetAddData_ConstructionBudget((int)GroupName_ConstructionBudget.DisposeCosts)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region データ追加：購入品をマージする
+        /// <summary>
+        /// データ追加：購入品をマージする
+        /// </summary>
+        /// <returns></returns>
+        private bool SetAddData_PurchaseCosts()
+        {
+            IOConstructionBudgetDetail DetailDB = new IOConstructionBudgetDetail();
+            try
+            {
+                // 工事予算書明細データを読み込む
+                string strSQL = "SELECT SUM(ESTIMATEPRICE), SUM(EXECUTIONAMOUNT), SUM(AMOUNTCONFIGRATE) FROM CONSTRUCTIONBUDGETDETAIL";
+                strSQL += DetailDB.CreatePrimarykeyString(AddingConstrCode);
+                strSQL += string.Format(" AND GROUPCOUNT = {0}", (int)GroupName_ConstructionBudget.PurchaseCosts);       // 購入品
+                ArrayList DetailList = new ArrayList();
+                if (!DetailDB.ExecuteReader(strSQL, ref DetailList)) return false;
+                if (DetailList.Count == 0) return true;
+
+                DataGridView dgv = dgvAllDisplay;
+                object[] wrkobj = (object[])DetailList[0];
+
+                // 行位置取得
+                int TargetLine = m_CostsRowCount[(int)CostsRowLine.PurchaseCostsRowLine];
+
+                DataGridViewRow RowData = dgv.Rows[TargetLine];
+
+                int[] NowValue = new int[3];
+                NowValue[0] = CommonMotions.cnvInt(RowData.Cells[(int)GridColumn.EstimatePrice].Value) + CommonMotions.cnvInt(wrkobj[0]);
+                NowValue[1] = CommonMotions.cnvInt(RowData.Cells[(int)GridColumn.ExecPrice].Value) + CommonMotions.cnvInt(wrkobj[1]);
+                NowValue[2] = CommonMotions.cnvInt(RowData.Cells[(int)GridColumn.Percent].Value) + CommonMotions.cnvInt(wrkobj[2]);
+
+                // データセット
+                RowData.Cells[(int)GridColumn.EstimatePrice].Value = NowValue[0].ToString("#,0");
+                RowData.Cells[(int)GridColumn.ExecPrice].Value = NowValue[1].ToString("#,0");
+                RowData.Cells[(int)GridColumn.Percent].Value = CalculattionPercent((double)NowValue[1]).ToString("0.00");
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                DetailDB.close(); DetailDB = null;
+            }
+        }
+        #endregion
+
+        #region データ追加：購入費等追加
+        /// <summary>
+        /// データ追加：購入費等追加
+        /// </summary>
+        /// <returns></returns>
+        private bool SetAddData_ConstructionBudget(int GroupNo)
+        {
+            IOConstructionBudgetDetail DetailDB = new IOConstructionBudgetDetail();
+            try
+            {
+                // 工事予算書明細データを読み込む
+                string strSQL = DetailDB.CreatePrimarykeyString(AddingConstrCode);
+                strSQL += string.Format(" AND GROUPCOUNT = {0}", GroupNo);
+                strSQL += " ORDER BY LineCount ASC";
+
+                ConstructionBudgetDetail DetailRec = new ConstructionBudgetDetail();
+                if (!DetailDB.SelectAction(strSQL, ref DetailRec)) return false;
+
+                int TargetLine = -1;
+                // データセット
+                switch (GroupNo)
+                {
+                    // 車両リース代
+                    case (int)GroupName_ConstructionBudget.VehicleLeaseFee:
+                        TargetLine = m_CostsRowCount[(int)CostsRowLine.VehicleLeaseFeeRowLine];
+                        break;
+                    // 交通費（通行料・電車代）
+                    case (int)GroupName_ConstructionBudget.TransportationCosts:
+                        TargetLine = m_CostsRowCount[(int)CostsRowLine.TransportationCostsRowLine];
+                        break;
+                    // 駐車場・資材置き場
+                    case (int)GroupName_ConstructionBudget.ParkingCosts:
+                        TargetLine = m_CostsRowCount[(int)CostsRowLine.ParkingCostsRowLine];
+                        break;
+                    // 宿泊費
+                    case (int)GroupName_ConstructionBudget.RoomChargeCosts:
+                        TargetLine = m_CostsRowCount[(int)CostsRowLine.RoomChargeCostsRowLine];
+                        break;
+                    // 処分費等
+                    case (int)GroupName_ConstructionBudget.DisposeCosts:
+                        TargetLine = m_CostsRowCount[(int)CostsRowLine.DisposeCostsRowLine];
+                        break;
+
+                    default:
+                        // その他の項目
+                        break;
+                }
+
+                DataGridView dgv = dgvAllDisplay;
+                DataGridViewRow RowData = dgv.Rows[TargetLine];
+
+                int[] NowValue = new int[3];
+                NowValue[0] = CommonMotions.cnvInt(RowData.Cells[(int)GridColumn.EstimatePrice].Value) + (int)DetailRec.EstimatePrice;
+                NowValue[1] = CommonMotions.cnvInt(RowData.Cells[(int)GridColumn.ExecPrice].Value) + (int)DetailRec.ExecutionAmount;
+
+                RowData.Cells[(int)GridColumn.EstimatePrice].Value = NowValue[0].ToString("#,0");
+                RowData.Cells[(int)GridColumn.ExecPrice].Value = NowValue[1].ToString("#,0");
+                RowData.Cells[(int)GridColumn.Percent].Value = CalculattionPercent((double)NowValue[1]).ToString("0.00");
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                DetailDB.close(); DetailDB = null;
+            }
+        }
+        #endregion
+
+        #region データ追加：人件費ブロック追加
+        /// <summary>
+        /// データ追加：人件費ブロック追加
+        /// </summary>
+        /// <returns></returns>
+        private bool SetAddData_WorkingValue()
+        {
+            IOConstructionBudgetDetail DetailDB = new IOConstructionBudgetDetail();
+            try
+            {
+                int GroupNo = (int)GroupName_ConstructionLedger.TransportationCosts + 1;
+                int icnt = 1;
+                // グループ名表示
+                CreateTitleRow(GroupNo, s_PersonnelExpensesGroup);
+
+                // 指導員給与
+                if (!SetAddData_AddWorkingRow(GroupNo, (int)GroupName_ConstructionBudget.InstructorCosts, icnt++)) return false;
+                // 副担当者給与
+                if (!SetAddData_AddWorkingRow(GroupNo, (int)GroupName_ConstructionBudget.AssistantCosts, icnt++)) return false;
+                // 担当者給与経費
+                if (!SetAddData_AddWorkingRow(GroupNo, (int)GroupName_ConstructionBudget.PayrollExpenses, icnt++)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                DetailDB.close(); DetailDB = null;
+            }
+        }
+        #endregion
+
+        #region データ追加：人件費を追加
+        /// <summary>
+        /// データ追加：人件費を追加
+        /// </summary>
+        /// <returns></returns>
+        private bool SetAddData_AddWorkingRow(int BlockNo, int GroupNo, int DataNo)
+        {
+            IOConstructionBudgetDetail DetailDB = new IOConstructionBudgetDetail();
+            try
+            {
+                // 工事予算書明細データを読み込む
+                string strSQL = DetailDB.CreatePrimarykeyString(AddingConstrCode);
+                strSQL += string.Format(" AND GROUPCOUNT = {0}", GroupNo);
+                strSQL += " ORDER BY LineCount ASC";
+
+                List<ConstructionBudgetDetail> DetailList = new List<ConstructionBudgetDetail>();
+                if (!DetailDB.SelectAction(strSQL, ref DetailList)) return false;
+                if (DetailList.Count == 0) return true;
+
+                DataGridView dgv = dgvAllDisplay;
+
+                ConstructionBudgetDetail DetailRec = DetailList[0];
+
+                int TargetLine = -1;
+                // データセット
+                switch (GroupNo)
+                {
+                    // 指導員費用
+                    case (int)GroupName_ConstructionBudget.InstructorCosts:
+
+                        TargetLine = m_CostsRowCount[(int)CostsRowLine.InstructorRowLine];
+                        GroupNo = (int)GroupName_ConstructionLedger.Instructor;
+                        // 指導員行に名前を入れる
+                        SetFirstStringName(ref DetailRec);
+                        // 一般ユーザーは指導員の給与を見えないようにする
+                        if (!CheckLeaderOrUser()) DetailRec.SecondString = string.Empty;
+                        break;
+                    // 副担当者給与費用
+                    case (int)GroupName_ConstructionBudget.AssistantCosts:
+
+                        TargetLine = m_CostsRowCount[(int)CostsRowLine.AssistantRowLine];
+                        GroupNo = (int)GroupName_ConstructionLedger.Assistant;
+                        // 副担当行に名前を入れる
+                        SetFirstStringName(ref DetailRec);
+                        // 一般ユーザーは副担当者の給与を見えないようにする
+                        if (!CheckLeaderOrUser()) DetailRec.SecondString = string.Empty;
+                        break;
+                    // 担当者給与費用
+                    case (int)GroupName_ConstructionBudget.PayrollExpenses:
+
+                        TargetLine = m_CostsRowCount[(int)CostsRowLine.PayrollRowLine];
+                        GroupNo = (int)GroupName_ConstructionLedger.Payroll;
+                        // 一般ユーザーは担当者の給与を見えないようにする
+                        if (!CheckLeaderOrUser()) DetailRec.SecondString = string.Empty;
+                        break;
+                    default:
+                        // その他の項目
+                        GroupNo = 0;
+                        break;
+                }
+
+                // データ行現番号取得
+                int FluctuationNo = m_AddingConstrCode % 100;
+                // 担当者等が同じかをチェックする
+                bool bExist = false;
+                for (int i = TargetLine; i < dgv.RowCount; i++)
+                {
+                    DataGridViewRow wrkRow = dgv.Rows[i];
+                    if (CommonMotions.cnvInt(wrkRow.Cells[(int)GridColumn.GroupCount].Value) != GroupNo) break;
+                    if (CommonMotions.cnvInt(wrkRow.Cells[(int)GridColumn.CompanyCode].Value) == DetailRec.CompanyCode)
+                    {
+                        bExist = true;
+                        break;
+                    }
+                    TargetLine++;
+                }
+
+                if (!bExist)
+                {
+                    object[] RowData = new object[dgv.Columns.Count];
+
+                    RowData[(int)GridColumn.No] = string.Format("{0}-{1}", BlockNo, DataNo);        // ここでの番号は見えないのでおかしくてもよい
+                    RowData[(int)GridColumn.FixFlg] = "*";
+                    RowData[(int)GridColumn.GroupCount] = GroupNo;
+                    RowData[(int)GridColumn.ItemName] = DetailRec.FirstString;
+                    RowData[(int)GridColumn.TextName] = DetailRec.SecondString;
+
+                    RowData[(int)GridColumn.CompanyType] = DetailRec.CompanyType;
+                    RowData[(int)GridColumn.CompanyCode] = DetailRec.CompanyCode;
+                    RowData[(int)GridColumn.CompanyName] = DetailRec.CompanyName;
+                    RowData[(int)GridColumn.EstimatePrice] = DetailRec.EstimatePrice.ToString("#,0");
+                    RowData[(int)GridColumn.ExecPrice] = DetailRec.ExecutionAmount.ToString("#,0");
+                    RowData[(int)GridColumn.Percent] = DetailRec.AmountConfigRate.ToString("0.00");
+                    RowData[(int)GridColumn.IndependentFlg] = "1";
+                    RowData[(int)GridColumn.FluctuationFlg] = FluctuationNo;
+
+                    // 合計欄位置取得
+                    int TotalPoint = dgv.ColumnCount + (int)ColPayTotal.Totals;
+                    RowData[TotalPoint] = "0";
+                    // 実績欄位置取得
+                    int ResultPoint = dgv.ColumnCount + (int)ColPayTotal.Results;
+                    RowData[ResultPoint] = DetailRec.ExecutionAmount.ToString("#,0");
+
+                    RowData[(int)GridColumn.TitleFlg] = "0";
+                    RowData[(int)GridColumn.TotalFlg] = "0";
+                    RowData[(int)GridColumn.BlankFlg] = "0";
+
+                    dgv.Rows.Insert(TargetLine, RowData);
+                }
+                else
+                {
+                    DataGridViewRow RowData = dgv.Rows[TargetLine];
+                    int EstimatePrice = CommonMotions.cnvInt(RowData.Cells[(int)GridColumn.EstimatePrice].Value) + (int)DetailRec.EstimatePrice;
+                    int ExecutionAmount = CommonMotions.cnvInt(RowData.Cells[(int)GridColumn.ExecPrice].Value) + (int)DetailRec.ExecutionAmount;
+
+                    RowData.Cells[(int)GridColumn.EstimatePrice].Value = EstimatePrice.ToString("#,0");
+                    RowData.Cells[(int)GridColumn.ExecPrice].Value = ExecutionAmount.ToString("#,0");
+                }
+
+                // 行数保持のエリアを更新する
+                SetCostsRowCount();
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                DetailDB.close(); DetailDB = null;
+            }
+        }
+        #endregion
+
     }
 }
